/*  QPEgui - qte/qpe gui plugin for xmms
 *  Copyright (C) 2002 p.nis/dolOps
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#define KEYDELAY 2

#define PLLOCK pthread_mutex_lock(&plmutex);
#define PLUNLOCK   pthread_mutex_unlock(&plmutex);

#include "config.h"
#include <malloc.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdlib.h>

#include <signal.h>
#include <unistd.h>
#include <stdio.h>

#include <string.h>
#include <pthread.h>
#include "xmms/plugin.h"
#include "xmms/input.h"


#include "xmmsgui2.h"
#include "libxmms/xmmsctrl.h"
#include "libxmms/configfile.h"
#include <qpe/qpeapplication.h>
#include <qpe/qcopenvelope_qws.h>
#include <qwidget.h>
#include "qlistbox.h"
#include <qtimer.h>
#include <qlabel.h>
#include <qlcdnumber.h>
#include <qslider.h>
#include <qstringlist.h>
#include "filebrowser.h"
#include "qtoolbutton.h"
#include "qinputdialog.h"
#include "moviewin.h"


static bool plchangevisible=TRUE;
static gboolean fullscreen=FALSE;
static gboolean infullscreen=FALSE;
xmmsgui *mw;

extern void disablesuspend(bool);
extern void disablelightoff(bool);
extern int mainargc;
extern char **mainargv;
extern "C" { 
    gboolean playlist_save(gchar *filename);
    long int input_time;
/*    void input_seek(int time);*/
}

struct sched_param schedparam;
static bool video=FALSE;
gboolean mainthreaddone=FALSE;
char checked[PLMAXLENGTH];
static void init(void);
static void cleanup(void);
static void configure(void);
static pthread_t mainthread;
pthread_t plthread;
pthread_attr_t threadattr;
pthread_mutex_t plmutex;
QTimer *timer;
static bool ignoreit=FALSE,posupdate=TRUE,moving=FALSE,sliding=FALSE;
bool exiting=FALSE;
void *updatelistbox(void *arg);
static char cucc[8192];
static long int keytime=0,key=0,totaltime,guitime;
QListBox *listbox;
FileBrowser* fd;


moviewinclass *moviewin;

GeneralPlugin sc_gp =
{
	NULL,			/* handle */
	NULL,			/* filename */
	-1,			/* xmms_session */
	NULL,			/* Description */
	init,
	NULL,
	configure,
	cleanup,
};

extern "C" { 
GeneralPlugin *get_gplugin_info(void)
{
	sc_gp.description = g_strdup_printf(("Qtopia gui for XMMS %s"), VERSION);
	return &sc_gp;
}
}

static void *mainthreadfunc(void *arg)
{
	int ret;
	QPEApplication a(mainargc,mainargv);
	a.setMainWidget( new xmmsgui(0,0,QWidget::WStyle_Customize | QWidget::WStyle_DialogBorder | QWidget::WStyle_Minimize) );
	mw->showMaximized();
	moviewin=new moviewinclass(mw,"MPlayer",QWidget::WStyle_Customize | QWidget::WStyle_DialogBorder | QWidget::WStyle_Minimize);
	moviewin->hide();
	listbox->hide();
	listbox->show();

	schedparam.sched_priority=20;
	pthread_attr_init(&threadattr);
	pthread_attr_setschedparam(&threadattr,&schedparam);
	pthread_create(&plthread, &threadattr, updatelistbox, NULL);
	pthread_attr_destroy(&threadattr);

	ret=a.exec();
	xmms_remote_quit(sc_gp.xmms_session);
	mainthreaddone=TRUE;
	pthread_exit(NULL);
}

static void init()
{
	ConfigFile *cfg;
	int sched=SCHED_RR;
	
	if ((cfg = xmms_cfg_open_default_file()) != NULL) {
	    xmms_cfg_read_boolean(cfg, "MPLAYER", "fullscreendefault", &fullscreen);	
	}
	
	struct sched_param schedparam;
	fprintf(stderr,"QPE init started\n");
	schedparam.sched_priority=1;
	pthread_attr_init(&threadattr);
	pthread_attr_setschedpolicy(&threadattr,sched);
	pthread_attr_setschedparam(&threadattr,&schedparam);
	pthread_attr_setdetachstate(&threadattr, PTHREAD_CREATE_DETACHED);
	pthread_create(&mainthread, &threadattr, mainthreadfunc, NULL);
	pthread_attr_destroy(&threadattr);
}

static void cleanup(void)
{
	disablesuspend(FALSE);
	disablelightoff(FALSE);
	while (!mainthreaddone) usleep(1000);
	usleep(1000);
}


static void configure(void)
{
}

void xmmsgui::eject() 
{

  QString *tmp;
  QStringList *sl;
  int i,nf;

  fd->showMaximized();
  sl=fd->getOpenFileNames();
  fd->hide();    
  
  if (sl->count()>0)
  {
   PLLOCK

   QObject::disconnect(ListBox1, SIGNAL(selectionChanged()),this,SLOT(songchange()));			 
   plchangevisible=FALSE;
   xmms_remote_stop(sc_gp.xmms_session);   
   while (xmms_remote_is_playing(sc_gp.xmms_session)) { usleep(1000); };
   xmms_remote_playlist_clear(sc_gp.xmms_session);
   for(i=0;i<ListBox1->count();i++) checked[i]=0;
   ListBox1->clear();
   while (0<sl->count())
   {
     strcpy(cucc,sl->first().latin1());
     if (*cucc!=0) xmms_remote_playlist_add_url_string(sc_gp.xmms_session,cucc);
     sl->remove(sl->begin());     
   }

   nf=xmms_remote_get_playlist_length(sc_gp.xmms_session);


   for(i=0;i<nf;i++)
   {
     ListBox1->insertItem(*(tmp=new QString(xmms_remote_get_playlist_file(sc_gp.xmms_session,i))));
     delete tmp;   
   }
   xmms_remote_set_playlist_pos(sc_gp.xmms_session,0);
   ListBox1->setCurrentItem(0);
   plchangevisible=TRUE;
   QObject::connect(ListBox1, SIGNAL(selectionChanged()),this,SLOT(songchange()));			    
   PLUNLOCK   
  }       
  delete sl;
}
void xmmsgui::play() 
{
  if (!xmms_remote_is_playing(sc_gp.xmms_session))
  {
    ignoreit=FALSE;
    songchange(); 
    xmms_remote_play(sc_gp.xmms_session);
  } else
  {
    xmms_remote_pause(sc_gp.xmms_session);
  }
  
}

void xmmsgui::stop() 
{
  xmms_remote_stop(sc_gp.xmms_session);
}
void xmmsgui::next() 
{
  xmms_remote_playlist_next(sc_gp.xmms_session);
}

void xmmsgui::prev() 
{
  xmms_remote_playlist_prev(sc_gp.xmms_session);
}

void xmmsgui::updategui()
{
  int pos,i,newseek=0;  
  char title[256];
  char scroll[256];
  char *t;
  QString *tmp;


  if (xmms_remote_is_playing(sc_gp.xmms_session))
  {  
      idletimer=0;
      pos=xmms_remote_get_playlist_pos(sc_gp.xmms_session);
      totaltime=xmms_remote_get_playlist_time(sc_gp.xmms_session,pos);      
      if (!strncmp(get_current_input_plugin()->description,"MPlayer",7))
      
      {
        if (video)
	{
	
	
	} 
	else {
	    video=TRUE;
	    moviewin->show();
	    this->hide();
	    this->show();	
	    this->Frame15->hide();
	    disablelightoff(TRUE);
	    PLLOCK
	    setfullscreen(fullscreen);
	    
	}
	/* UPDATE MOVIEWIN */      
    	if (!infullscreen){
	    guitime=input_time;
	    newseek=(long int)(guitime*100/totaltime);
	    if (!sliding) {
		if (Slider->value()!=newseek)
		{
		    QObject::disconnect(Slider, SIGNAL( valueChanged(int) ), this, SLOT(seekslidechanged(int)));
    		    Slider->setValue(newseek);  
		    QObject::connect(Slider, SIGNAL( valueChanged(int) ), this, SLOT(seekslidechanged(int)));
		}
	    }
	
	if (posupdate && ListBox1->currentItem()!=pos) 
    	{
	    QObject::disconnect(ListBox1, SIGNAL(selectionChanged()),this,SLOT(songchange()));			 
    	    ListBox1->setCurrentItem(pos);
	    QObject::connect(ListBox1, SIGNAL(selectionChanged()),this,SLOT(songchange()));		
	    setfullscreen(fullscreen);		
	    moviewin->hide();
	    moviewin->show();
	}
	}
	goto keys;        
      }	
      else {
        if (video)
	{
	    video=FALSE;
	    moviewin->hide();
	    this->hide();
	    this->show();	
	    setfullscreen(FALSE);
	    this->Frame15->show();
	    disablelightoff(FALSE);
	    PLUNLOCK
	}
      }
  
      disablesuspend(TRUE);	      

      guitime=xmms_remote_get_output_time(sc_gp.xmms_session);  
      totaltime=xmms_remote_get_playlist_time(sc_gp.xmms_session,pos);
      t=xmms_remote_get_playlist_title(sc_gp.xmms_session,pos);
      strcpy(title,t);      
      g_free(t);
      if (checked[pos]==0) 
      {
        PLLOCK
        checked[pos]=1;
	QObject::disconnect(ListBox1, SIGNAL(selectionChanged()),this,SLOT(songchange()));			 
        ListBox1->changeItem(*(tmp=new QString(title)),pos);
	QObject::connect(ListBox1, SIGNAL(selectionChanged()),this,SLOT(songchange()));			 
	PLUNLOCK
        delete tmp;	
      }
     
      strcat(title," -- ");
      scroll[27]=0;
      if ((strlen(title)>27) && (xmms_remote_get_playlist_length(sc_gp.xmms_session)!=0)) 
        for(i=0;i<27;i++) scroll[i]=title[(i+guitime/300)%strlen(title)];
      else strcpy(scroll,title);
    
      TextLabel2->setText(*(tmp=new QString(scroll)));
      delete tmp;
      
      if (!sliding)
      {
	newseek=(int)(guitime/(float)totaltime*100.0);
	if (Slider->value()!=newseek)
	{
	    QObject::disconnect(Slider, SIGNAL( valueChanged(int) ), this, SLOT(seekslidechanged(int)));
    	    Slider->setValue(newseek);  
	    QObject::connect(Slider, SIGNAL( valueChanged(int) ), this, SLOT(seekslidechanged(int)));
	}
	guitime/=1000;      
        if (guitime<100*60)
	{
    	    LCDsec1->display((int)guitime%10);
            LCDsec2->display((int)(guitime/10)%6);
	    LCDmin->display((int)guitime/60);
	} else
        {
    	    guitime/=60;  
    	    LCDsec1->display((int)guitime%10);
    	    LCDsec2->display((int)(guitime/10)%6);
	    LCDmin->display((int)guitime/60);    
        }
      }	else
      {
        guitime=(long int)totaltime*(long int)Slider->value()/100000;    
        if (guitime<100*60)
	{
    	    LCDsec1->display((int)guitime%10);
            LCDsec2->display((int)(guitime/10)%6);
	    LCDmin->display((int)guitime/60);
	} else
        {
    	    guitime/=60;  
    	    LCDsec1->display((int)guitime%10);
    	    LCDsec2->display((int)(guitime/10)%6);
	    LCDmin->display((int)guitime/60);    
        }
      }	
      

      if (posupdate && ListBox1->currentItem()!=pos) 
      {
	 QObject::disconnect(ListBox1, SIGNAL(selectionChanged()),this,SLOT(songchange()));			 
         ListBox1->setCurrentItem(pos);
	 QObject::connect(ListBox1, SIGNAL(selectionChanged()),this,SLOT(songchange()));		
      }
      
    }
  else
  {
    if (video)
    {	    
	    video=FALSE;
	    moviewin->hide();
	    this->hide();
	    this->show();	
	    this->Frame15->show();
	    setfullscreen(FALSE);
	    disablelightoff(FALSE);
	    PLUNLOCK
    }

    TextLabel2->setText(*(tmp=new QString("X Multimedia System")));
    delete tmp;
    if (++idletimer==50) {
	disablesuspend(FALSE);
    }
  };  
  

keys:  
  keytime+=1;
  if (( key==Key_Left || key==Key_Right) && (keytime>KEYDELAY))
  {
    switch (key) {
	case Key_Left:
	    QObject::disconnect(Slider, SIGNAL( valueChanged(int) ), this, SLOT(seekslidechanged(int)));
	    seekslidechanged(newseek-(keytime)/2);  
	    QObject::connect(Slider, SIGNAL( valueChanged(int) ), this, SLOT(seekslidechanged(int)));
	    break;
	case Key_Right:
	    QObject::disconnect(Slider, SIGNAL( valueChanged(int) ), this, SLOT(seekslidechanged(int)));
    	    seekslidechanged(newseek+(keytime)/2);  
	    QObject::connect(Slider, SIGNAL( valueChanged(int) ), this, SLOT(seekslidechanged(int)));
	    break;
	default:
	    break;
    }  
  }
  if (!infullscreen && plchangevisible) 
  {
    PLLOCK
    ListBox1->triggerUpdate(FALSE);
    plchangevisible=FALSE;
    PLUNLOCK
  }

}

void xmmsgui::songchange()
{
    int i;
    if (posupdate)
    {
        timer->stop();
	i=ListBox1->currentItem();
        xmms_remote_set_playlist_pos(sc_gp.xmms_session,i);
        usleep(5000);
        timer->start(GUIUPDATE);
    };
}
void xmmsgui::fileadd()
{

  QString *tmp;
  QStringList *sl;
  int i,nf;

  fd->showMaximized();
  sl=fd->getOpenFileNames();
  fd->hide();    

  nf=sl->count();    
  
  if (nf>0)
  { 
   i=xmms_remote_get_playlist_length(sc_gp.xmms_session);

   PLLOCK

   while (0<sl->count())
   {
     strcpy(cucc,sl->first().latin1());
     if (*cucc!=0) xmms_remote_playlist_add_url_string(sc_gp.xmms_session,cucc);
     sl->remove(sl->begin());     
   }

   nf=xmms_remote_get_playlist_length(sc_gp.xmms_session);

   for(;i<nf;i++)
   {
     ListBox1->insertItem(*(tmp=new QString(xmms_remote_get_playlist_file(sc_gp.xmms_session,i))));
     delete tmp;   
     checked[i]=0;
   }
   plchangevisible=TRUE;
   PLUNLOCK   
  }       
}

void xmmsgui::canceldel()
{
    int i,j,max;
    
    PLLOCK
    ListBox1->hide();
    for(i=0;i<ListBox1->count();i++)
	ListBox1->setSelected(i,FALSE);
    ListBox1->setSelectionMode(QListBox::Single);
    ListBox1->show();
    PLUNLOCK
    plchangevisible=TRUE;
    posupdate=TRUE;
    fileaddbut->show();
    savebut->show();
    movebut->show();
    disconnect(filedelbut, SIGNAL( clicked() ), this, SLOT( delall() ));
    connect(filedelbut, SIGNAL( clicked() ), this, SLOT ( filedel() ));
    disconnect(fileaddbut, SIGNAL( clicked() ), this, SLOT ( canceldel()));
    connect(fileaddbut, SIGNAL( clicked() ), this, SLOT ( fileadd()));

}

void xmmsgui::filedel()
{
    unsigned int i;

    urladdbut->hide();
    savebut->hide();
    movebut->hide();
    disconnect(filedelbut, SIGNAL( clicked() ), this, SLOT ( filedel()));
    connect(filedelbut, SIGNAL( clicked() ), this, SLOT ( delall()));
    disconnect(fileaddbut, SIGNAL( clicked() ), this, SLOT ( fileadd()));
    connect(fileaddbut, SIGNAL( clicked() ), this, SLOT ( canceldel()));

    posupdate=FALSE;
    PLLOCK
    ListBox1->hide();
    ListBox1->setSelectionMode(QListBox::Multi);
    ListBox1->show();
    for(i=0;i<ListBox1->count();i++)
	ListBox1->setSelected(i,FALSE);
    PLUNLOCK
    plchangevisible=TRUE;
}

void *updatelistbox(void *arg)
{
  int length,i;
  gchar *title;
  QString *tmp;
  
  while(!exiting)
  {
    length=xmms_remote_get_playlist_length(sc_gp.xmms_session);
    for (i=0;i<length;i++)
    {
      PLLOCK
      if ((checked[i]==0) && (i<xmms_remote_get_playlist_length(sc_gp.xmms_session))) 
      {
        checked[i]=1;
	title=xmms_remote_get_playlist_title(sc_gp.xmms_session,i);
	QObject::disconnect(listbox, SIGNAL(selectionChanged()),mw,SLOT(songchange()));		
	listbox->item(i)->setText(*(tmp=new QString(title)));
	delete tmp;	
	QObject::connect(listbox, SIGNAL(selectionChanged()),mw,SLOT(songchange()));		
	if (abs(listbox->topItem()+6-i)<6)  
	{ 
	  plchangevisible=TRUE;
	} 
	g_free(title);
      }
      PLUNLOCK	
      usleep(300);
    }    
  }
  pthread_exit(0);
}

void xmmsgui::urladd()
{
   bool ok=FALSE;
   
   *cucc=0;

   QString sl(QInputDialog::getText("Type in URL!","","http://anka.katedral.se:6581/fresh.ogg",&ok,this));
   strcpy(cucc,sl.latin1());
   if (*cucc!=0)
   {
    PLLOCK
    xmms_remote_playlist_add_url_string(sc_gp.xmms_session,cucc);
    ListBox1->insertItem(sl);
    checked[ListBox1->count()-1]=0;
    plchangevisible=TRUE;
    PLUNLOCK
   }
}

void xmmsgui::move()
{
    unsigned int i;
    if (!moving)
    {
	urladdbut->hide();
	savebut->hide();
	posupdate=FALSE;
        moving=TRUE;
	disconnect( fileaddbut, SIGNAL (clicked()), this, SLOT(fileadd()));
	disconnect( filedelbut, SIGNAL (clicked()), this, SLOT(filedel()));
	connect( fileaddbut, SIGNAL (clicked()), this, SLOT(moveup()));
	connect( filedelbut, SIGNAL (clicked()), this, SLOT(movedown()));


        ListBox1->setSelectionMode(QListBox::Single);
        for(i=0;i<ListBox1->count();i++)
    	    ListBox1->setSelected(i,FALSE);	    
    } else
    {
	ListBox1->setCurrentItem(xmms_remote_get_playlist_pos(sc_gp.xmms_session));
        moving=FALSE;
	posupdate=TRUE;
	urladdbut->show();
	savebut->show();
	disconnect( fileaddbut, SIGNAL (clicked()), this, SLOT(moveup()));
	disconnect( filedelbut, SIGNAL (clicked()), this, SLOT(movedown()));
	connect( fileaddbut, SIGNAL (clicked()), this, SLOT(fileadd()));
	connect( filedelbut, SIGNAL (clicked()), this, SLOT(filedel()));
    }    
}


void xmmsgui::moveup()
{
    int i;
    gchar *filename,*title;
    
    if (((i=ListBox1->currentItem())>-1) && (i>0))
    {
	if (i!=xmms_remote_get_playlist_pos(sc_gp.xmms_session))
	{
	    PLLOCK	
	    filename=strdup(xmms_remote_get_playlist_file(sc_gp.xmms_session,i));
	    title=strdup(xmms_remote_get_playlist_title(sc_gp.xmms_session,i));
	    xmms_remote_playlist_delete(sc_gp.xmms_session,i);
	    xmms_remote_playlist_ins_url_string(sc_gp.xmms_session,filename,i-1);
	    ListBox1->removeItem(i);
	    ListBox1->insertItem(title,i-1);
	    ListBox1->setCurrentItem(i-1);
	    checked[i-1]=1;
	    free(title);
	    free(filename);
	    PLUNLOCK
	}      
    }    
}


void xmmsgui::movedown()
{
    int i;
    gchar *filename,*title;
    
    if (((i=ListBox1->currentItem())>-1) && ((i+1)<ListBox1->count()))
    {
	if (i!=xmms_remote_get_playlist_pos(sc_gp.xmms_session))
	{
	    PLLOCK	
	    filename=strdup(xmms_remote_get_playlist_file(sc_gp.xmms_session,i));
	    title=strdup(xmms_remote_get_playlist_title(sc_gp.xmms_session,i));
	    xmms_remote_playlist_delete(sc_gp.xmms_session,i);
	    xmms_remote_playlist_ins_url_string(sc_gp.xmms_session,filename,i+1);	
	    ListBox1->removeItem(i);
	    ListBox1->insertItem(title,i+1);
	    ListBox1->setCurrentItem(i+1);
	    checked[i+1]=1;
	    free(title);
	    free(filename);
	    PLUNLOCK
	}            
    }    
}

void xmmsgui::save()
{
  QString *sl;

  fd->showMaximized();
  sl=fd->getSaveFileName();
  fd->hide();    

  strcpy(cucc,sl->latin1());
  if (*cucc!=0) 
  {
    playlist_save(cucc);
  }    
  delete sl;
}

void xmmsgui::delall()
{
    int i,j,max;
    
    PLLOCK
    max=ListBox1->count();
    for(i=0;i<ListBox1->count();i++)
    {
	if (ListBox1->isSelected(i))
	{
	    ListBox1->setSelected(i,FALSE);
	    if (!(xmms_remote_get_playlist_pos(sc_gp.xmms_session)==i && xmms_remote_is_playing(sc_gp.xmms_session)))
	    {
		ListBox1->removeItem(i);
		xmms_remote_playlist_delete(sc_gp.xmms_session,i);
		checked[i]=2;
		i--;
	    };
	}    		
    }
    for(i=j=0;i<max;i++) 
      if (checked[i]==2) 
      {
        j++;
        checked[i]=checked[i+j];    
	i--;
      }	    
    ListBox1->hide();
    ListBox1->setSelectionMode(QListBox::Single);
    ListBox1->show();
    PLUNLOCK
    plchangevisible=TRUE;

    posupdate=TRUE;
    urladdbut->show();
    savebut->show();
    movebut->show();
    disconnect(filedelbut, SIGNAL( clicked() ), this, SLOT( delall() ));
    connect(filedelbut, SIGNAL( clicked() ), this, SLOT ( filedel() ));
    disconnect(fileaddbut, SIGNAL( clicked() ), this, SLOT ( canceldel()));
    connect(fileaddbut, SIGNAL( clicked() ), this, SLOT ( fileadd()));
}

void xmmsgui::keyPressEvent( QKeyEvent *ev)
{
    if (!ev->isAutoRepeat())
    {
	    keytime=0;
	    key=ev->key();	    	
	    switch (ev->key())
	    {
		case Key_Up:
    		    Slider2->setValue(Slider2->value()+1);	
		    break;	
		case Key_Down:
		    Slider2->setValue(Slider2->value()-1);				
		    break;
		case Key_Left:
		case Key_Right:    
		case Key_Space:
		case Key_F33:
		case Key_Escape:
		    break;
		default: 
		    ev->ignore();		
	    }
    } else
    {
	switch (ev->key())
	{
	    case Key_Up:
    		Slider2->setValue(Slider2->value()+1);	
		break;	
	    case Key_Down:
		Slider2->setValue(Slider2->value()-1);				
		break;		
	    default:
		ev->ignore();
	}
    }
}
void xmmsgui::keyReleaseEvent( QKeyEvent *ev)
{

    if (!ev->isAutoRepeat())
    {
	    if (ev->key()==key)
	    {
		switch (key) 
		{
		    case Key_Left:
			if (keytime<KEYDELAY) prev();	
			key=0;
			break;	
		    case Key_Right:
			if (keytime<KEYDELAY) next();	
			key=0;
			break;		
		    case Key_F33:
			stop();
			break;
		    case Key_Space:
			play();	
		    case Key_Up:
			key=0;
			break;	
		    case Key_Down:
			key=0;
			break;		
		    case Key_Escape:
			break;
		    default: ev->ignore();
		}
	    } else ev->ignore();		 
    } else ev->ignore();		 
}

void xmmsgui::volslidemoved(int vol)
{
    int vl,vr;
    
    vl=vr=vol;
    xmms_remote_set_volume(sc_gp.xmms_session,vl,vr);
}

void xmmsgui::seekslidechanged(int seek)
{
    long int to,pos;
    if (!sliding) 
    {        
	to=(long int)totaltime*(long int)seek/100000;    
	if (to<0) to=0;
        input_seek(to);
    }
}

void xmmsgui::seeksliderel()
{
    long int to;
    
    sliding=FALSE;
    Slider->setTracking(FALSE);
    to=(long int)totaltime*(long int)Slider->value()/100000;    
    input_seek(to);
}
void xmmsgui::seekslidepress()
{
    sliding=TRUE;
    Slider->setTracking(TRUE);
}
void xmmsgui::setfullscreen(bool fs){
// From www.zauruszone.com/howtos
    if (fs && (size()!=qApp->desktop()->size())) {
	setFixedSize(qApp->desktop()->size());
	infullscreen=TRUE;
	moviewin->setGeometry(0,0,240,320);	
	// This call is needed because showFullScreen won't work
	// correctly if the widget already considers itself to be fullscreen.
	showNormal();
	// This is needed because showNormal() forcefully changes the window
	// style to WSTyle_TopLevel.
	reparent(0, WStyle_Customize | WStyle_NoBorder, QPoint(0,0));
	// Enable fullscreen.
	showFullScreen();
	
    } 
    else if (!fs) {
	hide();
	setFixedSize(QSize(240,285));
    	showNormal();
	showMaximized();	    
	moviewin->setGeometry(0,87,240,218);
	infullscreen=FALSE;
    }
}

void xmmsgui::repeat() {
    if (!xmms_remote_is_repeat(sc_gp.xmms_session)) {
	rep->show();
	norep->hide();
    }
    else {
	norep->show();
	rep->hide();    
    }
    xmms_remote_toggle_repeat(sc_gp.xmms_session);
}

void xmmsgui::shuffle() {
    if (!xmms_remote_is_shuffle(sc_gp.xmms_session)) {
	shuf->show();
	noshuf->hide();
    }
    else {
	noshuf->show();
	shuf->hide();    
    }
    xmms_remote_toggle_shuffle(sc_gp.xmms_session);
}

