
#include "xtoolbutton.h"
#ifndef QT_NO_TOOLBUTTON

#include <qdrawutil.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qwmatrix.h>
#include <qapplication.h>
#include <qtooltip.h>
#include <qtoolbar.h>
#include <qimage.h>
#include <qiconset.h>
#include <qtimer.h>
#include <qpopupmenu.h>
#include <qguardedptr.h>
#include <qiconset.h>

//static QToolButton * threeDeeButton = 0;



/*! Destroys the object and frees any allocated resources. */

//QToolButton::~QToolButton()
//{
//    d->popupTimer = 0;
//    d->popup = 0;
//    delete d;
//    delete s;
//    delete son;
//    threeDeeButton = 0;
//}

/*!  \reimp
*/



QSize XToolButton::sizeHint() const
{
    constPolish();

    int w = 0;
    int h = 0;

    if ( !text().isNull()) {
	w = fontMetrics().width( text() );
	h = fontMetrics().height(); // boundingRect()?
    } else if ( usesBigPixmap() ) {
	QPixmap pm = iconSet(TRUE).pixmap(QIconSet::Large, QIconSet::Normal);
	w = pm.width();
	h = pm.height();
	if ( w < 32 )
	    w = 32;
	if ( h < 32 )
	    h = 32;
    } else {
	w = h = 16;
	QPixmap pm = iconSet(TRUE).pixmap(QIconSet::Small, QIconSet::Normal);
	w = pm.width();
	h = pm.height();
#ifndef _WS_QWS_ // shouldn't be on any platform...
	if ( w < 16 )
	    w = 16;
	if ( h < 16 )
	    h = 16;
#endif
    }

    if ( usesTextLabel() ) {
	h += 4 + fontMetrics().height();
	int tw = fontMetrics().width( textLabel() ) + fontMetrics().width("  ");
	if ( tw > w )
	    w = tw;
    }
    return QSize( w /*+ 7*/, h /*+ 6*/ ).expandedTo( QApplication::globalStrut() );
}



/*! \reimp
 */
void XToolButton::drawButton( QPainter * p )
{
    style().drawToolButton( this, p );
    drawButtonLabel( p );
}

/*
!\reimp
 */
void XToolButton::drawButtonLabel( QPainter * p )
{
    int sx = 0;
    int sy = 0;
    int x=0, y=0, w, h;

    w=width();h=height();

    if (isDown() || (isOn()/*&&!son*/) ) {
	style().getButtonShift(sx, sy);
	
//	x+=sx;
//	y+=sy;
    }
//    if ( hasArrow ) {
//	style().drawArrow( p, d->arrow, isDown(), x, y, w, h, colorGroup(), isEnabled() );
//	return;
//    }

    if ( !text().isNull() ) {
	style().drawItem( p, x, y, w, h,
			  AlignCenter + ShowPrefix,
			  colorGroup(), isEnabled(),
			  0, text() );
    } else {
	QPixmap pm;
	if ( usesBigPixmap() ) {
	    if ( !isEnabled() )
		pm = iconSet( isOn() ).pixmap( QIconSet::Large, QIconSet::Disabled );
	    else if ( uses3D() )
		pm = iconSet( isOn() ).pixmap( QIconSet::Large, QIconSet::Active );
	    else
		pm = iconSet( isOn() ).pixmap( QIconSet::Large, QIconSet::Normal );
	} else {
	    if ( !isEnabled() )
		pm = iconSet( isOn() ).pixmap( QIconSet::Small, QIconSet::Disabled );
	    else if ( uses3D() )
		pm = iconSet( isOn() ).pixmap( QIconSet::Small, QIconSet::Active );
	    else
		pm = iconSet( isOn() ).pixmap( QIconSet::Small, QIconSet::Normal );
	}


        style().drawItem( p, x, y, w, h,
		      AlignCenter, colorGroup(), TRUE, &pm, QString::null );
	
	if (isDown() || (isOn()/*&&!son*/) ) {
	    style().getButtonShift(sx, sy);
	    style().drawRect(p,x,y,w,h, QColor(255,255,255) );	
//		x+=sx;
//		y+=sy;
	}
	
    }
}


#endif

