#include <xmms/configfile.h>
#include <xmms/util.h>
#include <gtk/gtk.h>

#include "configure.h"

FCpluginConfig fc_myConfig;

static void config_ok(GtkWidget *widget, gpointer data);

static GtkWidget *fc_config_window = NULL;

static gchar configSection[] = "FutureComposer";

static GtkWidget *Bits16;
static GtkWidget *Bits8;

static GtkWidget *Stereo;
static GtkWidget *Mono;

static GtkWidget *Sample_44;
static GtkWidget *Sample_22;
static GtkWidget *Sample_11;

static const gint FREQ_SAMPLE_44 = 44100;
static const gint FREQ_SAMPLE_22 = 22050;
static const gint FREQ_SAMPLE_11 = 11025;

void fc_ip_load_config()
{
    ConfigFile *cfg;
    gchar *filename;

    fc_myConfig.frequency = FREQ_SAMPLE_44;
    fc_myConfig.precision = 8;
    fc_myConfig.channels = 1;
    
    filename = g_strconcat(g_get_home_dir(), "/.xmms/config", NULL);
    if ((cfg = xmms_cfg_open_file(filename)))
    {
        xmms_cfg_read_int(cfg, configSection, "frequency", &fc_myConfig.frequency);
        xmms_cfg_read_int(cfg, configSection, "precision", &fc_myConfig.precision);
        xmms_cfg_read_int(cfg, configSection, "channels", &fc_myConfig.channels);

        xmms_cfg_free(cfg);
    }
}

void fc_ip_configure()
{
}

static void config_ok(GtkWidget * widget, gpointer data)
{
}
