/*
 * xmms-mad - mp3 plugin for xmms
 * Copyright (C) 2001-2002 Sam Clegg - See COPYING
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Rev: 6 $
 * $URL: file:///var/lib/svn/xmms-mad/src/xmms-mad.h $
 */
#ifndef XMMS_MAD_H
#define XMMS_MAD_H

#define G_LOG_DOMAIN "xmms-mad"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <xmms/plugin.h>
#include <xmms/titlestring.h>
#include <id3tag.h>
#include <mad.h>

#include "xing.h"

struct mad_info_t
{
  /* flags */
  int stop;
  int seek;                   /**< seek time in seconds */

  /* state */
  unsigned int current_frame; /**< current mp3 frame */
  mad_timer_t pos;            /**< current play position */

  /* song info */
  unsigned int vbr;           /**< bool: is vbr? */
  unsigned int bitrate;       /**< avg. bitrate */
  unsigned int freq;          /**< sample freq. */
  unsigned int mpeg_layer;    /**< mpeg layer */
  unsigned int mode;          /**< mpeg stereo mode */
  unsigned int channels;
  int frames;                 /**< total mp3 frames or -1 */
  int fmt;                    /**< sample format */
  int size;                   /**< file size in bytes or -1 */
  char *title;                /**< title for xmms */
  mad_timer_t duration;       /**< total play time */
  struct id3_tag *tag;
  struct id3_file *id3file;
  struct xing xing;

  /* data access */
  char *url;
  char *filename;
  int infile;

  int remote;
  struct streamdata_t *sdata; /**< stream data for remote connections */
};

void *decode (void *arg);
void xmmsmad_error (char *fmt, ...);
extern InputPlugin mad_plugin;   /**< the plugin itself */
extern long int HTTP_BUFFER_SIZE;
#endif /* !XMMS_MAD_H */
